/* 
 * File:   ltest2.h
 * Author: Pavel
 *
 * Created on 15. ervna 2018, 18:38
 */


#ifndef LTEST1_H
#define	LTEST1_H

/* CONFIG1L*/
#pragma config RETEN = OFF    // VREG Sleep Enable bit->Ultra low-power regulator is Disabled (Controlled by REGSLP bit)
#pragma config INTOSCSEL = HIGH    // LF-INTOSC Low-power Enable bit->LF-INTOSC in High-power mode during Sleep
#pragma config SOSCSEL = DIG    // SOSC Power Selection and mode Configuration bits->High Power SOSC circuit selected
#pragma config XINST = OFF    // Extended Instruction Set->Disabled

// CONFIG1H
#pragma config FOSC = EC3   //Oscillator->External  oscillator 16 MHz
#pragma config PLLCFG = OFF    // PLL x4 Enable bit->Disabled
#pragma config FCMEN = OFF    // Fail-Safe Clock Monitor->Disabled
#pragma config IESO = OFF    // Internal External Oscillator Switch Over Mode->Disabled

// CONFIG2L
#pragma config PWRTEN = ON   // Power Up Timer->Disabled
#pragma config BOREN = SBORDIS    // Brown Out Detect->Enabled in hardware, SBOREN disabled
#pragma config BORV = 3    // Brown-out Reset Voltage bits->1.8V
#pragma config BORPWR = ZPBORMV    // BORMV Power level->ZPBORMV instead of BORMV is selected

// CONFIG2H
#pragma config WDTEN = OFF    // Watchdog Timer->WDT disabled in hardware; SWDTEN bit disabled
#pragma config WDTPS = 1048576    // Watchdog Postscaler->1:1048576

// CONFIG3H
#pragma config CANMX = PORTC    // ECAN Mux bit->ECAN TX and RX pins are located on RC6 and RC7
#pragma config MSSPMSK = MSK7    // MSSP address masking->7 Bit address masking mode
#pragma config MCLRE = ON    // Master Clear Enable->MCLR Enabled, RE3 Disabled

// CONFIG4L
#pragma config STVREN = ON    // Stack Overflow Reset->Enabled
#pragma config BBSIZ = BB2K    // Boot Block Size->2K word Boot Block size

// CONFIG5L
#pragma config CP0 = OFF    // Code Protect 00800-01FFF->Disabled
#pragma config CP1 = OFF    // Code Protect 02000-03FFF->Disabled
#pragma config CP2 = OFF    // Code Protect 04000-05FFF->Disabled
#pragma config CP3 = OFF    // Code Protect 06000-07FFF->Disabled

// CONFIG5H
#pragma config CPB = OFF    // Code Protect Boot->Disabled
#pragma config CPD = OFF    // Data EE Read Protect->Disabled

// CONFIG6L
#pragma config WRT0 = OFF    // Table Write Protect 00800-01FFF->Disabled
#pragma config WRT1 = OFF    // Table Write Protect 02000-03FFF->Disabled
#pragma config WRT2 = OFF    // Table Write Protect 04000-05FFF->Disabled
#pragma config WRT3 = OFF    // Table Write Protect 06000-07FFF->Disabled

// CONFIG6H
#pragma config WRTC = OFF    // Config. Write Protect->Disabled
#pragma config WRTB = OFF    // Table Write Protect Boot->Disabled
#pragma config WRTD = OFF    // Data EE Write Protect->Disabled

// CONFIG7L
#pragma config EBTR0 = OFF    // Table Read Protect 00800-01FFF->Disabled
#pragma config EBTR1 = OFF    // Table Read Protect 02000-03FFF->Disabled
#pragma config EBTR2 = OFF    // Table Read Protect 04000-05FFF->Disabled
#pragma config EBTR3 = OFF    // Table Read Protect 06000-07FFF->Disabled

// CONFIG7H
#pragma config EBTRB = OFF    // Table Read Protect Boot->Disabled

#define BFS 64   // FIFO
#define COL1 0
#define BORD 0x08
#define DOT 0x10
#define OVR 0x10
#define COL0 0x20
#define XOR 0x40
#define CORN 0x80
#define BIG 0x80
#define BOLD 1
#define STND 0
#define NX  0xA0
#define NY  0xA0

#define CS0 PORTDbits.RD0  //3 x mcp23s17
#define CS94 PORTDbits.RD1  //IC7 4094
#define CSEE PORTDbits.RD2  // IC12 EEPROM
#define CSSPI PORTDbits.RD3 // ext. SPI 
#define RES PORTEbits.RE1
#define DI PORTCbits.RC1 
#define EN PORTCbits.RC0
 
#define SAOEX 2
#define REOST 1

#define V53   0x0001
#define TRAPS 0x0002
#define MENSN 0x0004 
#define REZR  0x0008
#define VDDIC 0x0010 
#define OUTE  0x0020
#define PULE  0x0040
#define INTSN 0x0080

#define RESA  0x0100
#define ATRAP 0x0200
#define AINT  0x0400
#define BINT  0x0800
#define BTRAP 0x1000
#define RESB  0x2000
#define INTE  0x4000
#define CYKL  0x8000 

#define FREQ  0x04
#define SPI   0x01
#define TEMP  0x02

struct BUTS{char b8; char b2;};
struct ATR{char bold; char tmod; char rend; char stpx; char stpy; char nx; char ny; char wx1; char wx2; char wy1; char wy2; char wdx; char wdy; char cx; char cy;};



void Sdelay(unsigned int usec);
void Delay(int ms);
void Udelay(char dl);
void EWrite(char adr, char val);
char ERead(char adr);
void SPIOpen(void);
void SPIInit(char *val);
char SPIRead(char adr, char reg);
unsigned int SPIRead2(char adr, char reg);
void SPISend1(char adr, char reg, char val);
void SPISend2(char adr, char reg, unsigned int val);
struct BUTS ReadButs(void);
void LEDS(char tgreen, char tred, char tSM);
void WriteLCD(char dat, char cd);
//void init_1(void);
void init_2(void);
//void lcd_text(char x, char y, char *str1);
void GbufToLCD(void);
void Pix(signed char x, signed char y, signed char inv);
void Line(char x1, char x2, char y1, char y2, char t);
void Bord1(char x1, char x2, char y1, char y2, char tl);
void Bord2(char x, char dx, char y, char dy, char tl);
void Attrib(char wi, char bld, char md, char wx, char wy, char wdx, char wdy, char sx, char sy, char re);
void GbufFill(char ch);
char WinKamChr(char ck);
void Ch8(char x, char y, char  *ch, char mod);
void Ch16(char x, char y, char  *ch, char mod);
void Char16(char x, char y, char ch, char mod);
void Char8(char x, char y, char ch, char mod);
void Char8d(char x, char y, char ch, char mod);
void Text(char x, char y, char stpx, char stpy, char *str, char mod);
void Textd(char x, char y, char stpx, char stpy, char *str, char mod);
void TextA(char x, char y, char *str);
void TextAd(char x, char y, char *str);
void Rect(char x1, char x2, char y1, char y2, char tmod);
void Rect2(char x, char dx, char y, char dy, char tmod);
void Dil(char mod, unsigned int dilinp, char *ps, unsigned flags);
void Input(char y);
void Output(char y, char send);
void Direct(char y);
void Pullup(char y);
void Spullup(void);
void Inter(char y);
void Flags(char y, char echo);
void Levels(char y, char un);
void Reg94(char reg);
void Temp(void);
void USBrw(void);
void Poff(void);
void BaudSet(char uart);
void OpenUART(char uart);
void Syst(char sw);
void Puls(char sw);
void SaveE(void);
char ReadE(void);
void InitPar();
void Sound(char per, unsigned ts);
void VDD(char x, char y);
void Sound(char per, unsigned int ts);
void Light(char in);
char pull_char(void);
void push_char(char c);
void MeHelp(char mn);
void THelp(char tn);
void Ramrw(char rw, unsigned long adr, char *data, char len);
void ICpar(char in);
char *GetICPins(char x);
char *Volts(char vi);
void MpxAdr(char un);
char GetUn(void);
void Funct(void);
unsigned SPIr2(void);
void FreqCnt(void);



#endif 